cc.Node.prototype.findComponent = function(t) {
return this.getComponent(t) || this.addComponent(t);
};

cc.Node.prototype.$ = function(t, e = !1) {
return "string" == typeof t ? cc.find(t, this) : e ? this.getComponentInChildren(t) : this.getComponent(t);
};

cc.Node.prototype.hideChildren = function() {
this.children.forEach(t => t.hide());
};

cc.Node.prototype.show = function() {
this.active = !0;
};

cc.Node.prototype.hide = function() {
this.active = !1;
};

cc.Node.prototype.check = function() {
this.isChecked = !0;
};

cc.Node.prototype.uncheck = function() {
this.isChecked = !1;
};

cc.Node.prototype.getPhyCollider = function() {
return this.$(cc.PhysicsBoxCollider) || this.$(cc.PhysicsCircleCollider) || this.$(cc.PhysicsPolygonCollider);
};

cc.Node.prototype.destroyAllChildrens = function(t) {
this.getComponentsInChildren(t).forEach(t => t.node.destroy());
};

cc.Node.prototype.toggle = function() {
this.active = !this.active;
};

cc.Node.prototype.setLabel = function(t) {
this.getComponent(cc.Label).string = t.toString();
};

cc.Node.prototype.setText = function(t) {
this.getComponent(cc.RichText).string = t.toString();
};

cc.Node.prototype.setSpriteFrame = function(t) {
this.getComponent(cc.Sprite).spriteFrame = t;
};

cc.Node.prototype.setProgress = function(t) {
this.getComponent(cc.ProgressBar).progress = t;
};

cc.Node.prototype.click = function(t = null, e = 0) {
this.on("touchend", function(e) {
t && t(e);
});
this.findComponent(cc.Button).transition = e ? cc.Button.Transition.SCALE : cc.Button.Transition.COLOR;
};

Object.defineProperty(Array.prototype, "last", {
get() {
return this[this.length - 1];
}
});

Array.prototype.init = function(t, e) {
for (;t > 0; ) this[--t] = e >= 0 ? e : t;
return this;
};

String.prototype.toNumber = function() {
return +this;
};

String.prototype.toFormat = function(t) {
return this.replace(/\d+$/, t + "");
};

String.prototype.format = function(t) {
return this.replace(/\d/, t + "");
};

cc.Animation.prototype.fadeIn = function(t) {
this.playAdditive(t, 0);
};

cc.Animation.prototype.reset = function() {
this.setCurrentTime(0);
};

cc.Animation.prototype.gotoAndStopByFrame = function(t, e) {
this.setCurrentTime(e, t);
};

cc.Animation.prototype.getState = function(t) {
return {
isPlaying: this.getAnimationState(t)
};
};

cc.Tween.quadOut = "quadOut";

cc.Tween.quadInOut = "quadInOut";

cc.Tween.cubicIn = "cubicIn";

cc.Tween.cubicOut = "cubicOut";

cc.Tween.cubicInOut = "cubicInOut";

cc.Tween.quartIn = "quartIn";

cc.Tween.quartOut = "quartOut";

cc.Tween.quartInOut = "quartInOut";

cc.Tween.quintIn = "quintIn";

cc.Tween.quintOut = "quintOut";

cc.Tween.quintInOut = "quintInOut";

cc.Tween.sineIn = "sineIn";

cc.Tween.sineOut = "sineOut";

cc.Tween.sineInOut = "sineInOut";

cc.Tween.expoIn = "expoIn";

cc.Tween.expoOut = "expoOut";

cc.Tween.expoInOut = "expoInOut";

cc.Tween.circIn = "circIn";

cc.Tween.circOut = "circOut";

cc.Tween.circInOut = "circInOut";

cc.Tween.elasticIn = "elasticIn";

cc.Tween.elasticOut = "elasticOut";

cc.Tween.elasticInOut = "elasticInOut";

cc.Tween.backIn = "backIn";

cc.Tween.backOut = "backOut";

cc.Tween.backInOut = "backInOut";

cc.Tween.bounceIn = "bounceIn";

cc.Tween.bounceOut = "bounceOut";

cc.Tween.bounceInOut = "bounceInOut";

cc.Tween.smooth = "smooth";

cc.Tween.fade = "fade";